# React

Whether you call it a framework, a library, or a lifestyle, React is a very popular tool to build sites with. Our tracking script works with SPAs (single page application) too but the code to embed it to your site is a little more complicated.

There are many ways to embed custom script tags into your site, see [React Helmet](https://www.npmjs.com/package/react-helmet) for an npm package. The solution below does not require any package installation. It uses [Hooks](https://reactjs.org/docs/hooks-effect.html), which were introduced in React 16.8, to call the script once the component is mounted.

Don’t forget to replace `YOUR_API_KEY` with your actual API key.

```javascript
useEffect(() => {
  const script = document.createElement('script');
  script.src = "https://cdn.jsdelivr.net/npm/hockeystack@latest/hockeystack.min.js";
  script.async = true;
  script.dataset.apikey = "YOUR_API_KEY";
  script.dataset.cookieless = 1;
  script.dataset.autoIdentify = 1;
  document.head.appendChild(script);
}, []);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.hockeystack.com/technical-details/tracking/implementation/react.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
